<template>
  <el-dialog
    :title="!dataForm.id ? '新增' : '编辑'"
    :close-on-click-modal="false"
    :visible.sync="visible">
    <el-form :model="dataForm" :rules="dataRule" ref="dataForm" @keyup.enter.native="handleConfirm()" label-width="80px">
      <el-form-item label="参数名" prop="paramKey">
        <el-input v-model="dataForm.paramKey" placeholder="参数名"></el-input>
      </el-form-item>
      <el-form-item label="参数值" prop="paramValue">
        <el-input v-model="dataForm.paramValue" placeholder="参数值"></el-input>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="dataForm.remark" placeholder="备注"></el-input>
      </el-form-item>
    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button @click="visible = false">取消</el-button>
      <el-button type="primary" @click="handleConfirm()">确定</el-button>
    </span>
  </el-dialog>
</template>

<script>
  import { apiSysConfigInfo, apiSysConfigConfirm } from '@/api/api_sys'

  export default {
    data () {
      return {
        visible: false,
        dataForm: {
          id: 0,
          paramKey: '',
          paramValue: '',
          remark: ''
        },
        dataRule: {
          paramKey: [{ required: true, message: '参数名不能为空', trigger: 'blur' }],
          paramValue: [{ required: true, message: '参数值不能为空', trigger: 'blur' }]
        },
        apiType: '' // api类型
      }
    },
    methods: {
      init (id) {
        this.visible = true
        if (id) {
          this.dataForm.id = id || 0
          this.handleEdit()
          this.apiType = '/update'
        } else {
          this.apiType = '/save'
        }
      },
      handleEdit () {
        apiSysConfigInfo({}, `/${this.dataForm.id}`).then(res => {
          if (res && res.code === 0) {
            this.dataForm.paramKey = res.config.paramKey
            this.dataForm.paramValue = res.config.paramValue
            this.dataForm.remark = res.config.remark
          }
        })
      },
      // 提交
      handleConfirm () {
        this.$refs['dataForm'].validate((valid) => {
          if (valid) {
            let params = {
              'id': this.dataForm.id || undefined,
              'paramKey': this.dataForm.paramKey,
              'paramValue': this.dataForm.paramValue,
              'remark': this.dataForm.remark
            }
            apiSysConfigConfirm(params, this.apiType).then(res => {
              if (res && res.code === 0) {
                this.$message({
                  message: '操作成功',
                  type: 'success',
                  duration: 1500,
                  onClose: () => {
                    this.visible = false
                    this.$emit('refreshDataList')
                  }
                })
              } else {
                this.$message.error(res.msg)
              }
            })
          }
        })
      }
    }
  }
</script>
